<template>
  <div>
    <VCard
      :class="['time-curso', $vuetify.breakpoint.smAndUp && 'horizontal-card']"
      outlined
    >
      <VImg :src="src" />

      <VCardText>
        <div class="d-flex align-center">
          <p class="display-1 primary--text mb-0">
            {{ title }}
          </p>
          <VSpacer />
          <VIcon>mdi-clock-outline</VIcon>{{ time }}
        </div>
        <VIcon
          v-for="(s, i) in stars"
          :key="`star-${i}`"
          color="warning"
        >
          mdi-{{ starType(parseFloat(s)) }}
        </VIcon>

        <VBreadcrumbs
          :items="subTitle"
          class="py-0"
        >
          <template v-slot:divider>
            <VIcon>mdi-circle-medium</VIcon>
          </template>
        </VBreadcrumbs>

        <div
          v-if="tags"
          class="pt-3"
        >
          <VChip
            v-for="(t, i) in tags"
            :key="`tag-${i}`"
            :class="['text-uppercase font-weight-medium', i > 0 && 'ml-3']"
          >
            {{ t }}
          </VChip>
        </div>

        <div
          v-if="usersId"
          class="pt-3"
        >
          <VAvatar
            v-for="(u, i) in usersId"
            :key="`avatar-${i}`"
            :size="32"
            :class="i > 0 && 'ml-3'"
          >
            <img :src="`https://randomuser.me/api/portraits/men/${parseFloat(u)}.jpg`">
          </VAvatar>
        </div>

        <VProgressLinear
          class="mt-5"
          color="light-blue"
          height="10"
          :value="progress"
          striped
        />
      </VCardText>
    </VCard>
    <VLayout
      row
      wrap
    >
      <VFlex
        offset-sm5
        offset-md4
        py-5
      >
        <p
          v-if="resume"
          class="mx-4"
        >
          {{ resume }}
        </p>
      </VFlex>
    </VLayout>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'nuxt-property-decorator';

@Component({
  methods: {
    starType(n: number) {
      switch (n) {
        case 1:
          return 'star';
        case 2:
          return 'star-half';
        default:
          return 'star-outline';
      }
    },
  },
})
export default class TimeCurso extends Vue {
  @Prop(String)
  readonly src!: string

  @Prop(String)
  readonly title!: string

  @Prop(Array)
  readonly subTitle!: string[]

  @Prop(String)
  readonly time!: string

  @Prop(Array)
  readonly stars!: number[]

  @Prop(Array)
  readonly tags!: string[]

  @Prop(Array)
  readonly usersId!: number[]

  @Prop(Number)
  readonly progress!: number

  @Prop(String)
  readonly resume!: string
}
</script>

<style lang="stylus" scoped>
.time-curso
  &.horizontal-card
    display flex
    flex-direction row
    .v-image
      height 100% !important
      flex auto
      border-radius 3px 0 0 3px !important
    .v-card__text
      min-width 280px
  .v-breadcrumbs
      display inline-flex
</style>
